#!/usr/bin/env python

'''Service directory query program'''
__revision__ = '$Revision: 1.16 $'

from sys import argv
from sss.ssslib import comm_lib, ConnectError
from elementtree.ElementTree import XML

comm = comm_lib(debug=('-d' in argv))
try:
    handle = comm.ClientInit('service-directory')
except ConnectError, msg:
    print "Error connecting to service directory: %s" % (msg)
    raise SystemExit, 1
comm.SendMessage(handle, '''<get-location><location component='*' host='*' port='*' ''' +
                 '''protocol='*' schema_version='*' tier='*'/></get-location>''')
response = comm.RecvMessage(handle)
comm.ClientClose(handle)
element = XML(response)
# first get data and figure out widths
output = [("Service", "Protocol", "Location", "Version", "Tier")]
for service in element.findall(".//location"):
    output.append((service.get('component'), service.get('protocol'),
                   "%s:%s" % (service.get('host'), service.get('port')), service.get('schema_version'),
                   service.get('tier')))

lendata = [[len(item) for item in line] for line in output]
fsizes = tuple([max([x[row] for x in lendata]) for row in range(len(lendata[0]))])
fstring = "%%%ss   %%%ss   %%%ss   %%%ss   %%%ss" % fsizes
linelen = reduce(lambda x, y:x+y, fsizes) + 12
output.sort()
for data in output:
    print fstring % data
    if data[0] == "Service":
        print linelen * "="
