#include<ssslib.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>

struct framing_bytecount_state {
  int sss_errno;
  int debug;
  struct transport *transport;
};

void *framing_bytecount_LTX_framing_getstate(SSS_ConfigDict cfg,int debug,void *transport){
  struct framing_bytecount_state *ret;

  if (debug)
    printf("framing_bytecount: starting getstate\n");

  ret = malloc(sizeof(struct framing_bytecount_state));

  ret->transport = transport;

  ret->debug = debug;

  if (debug)
    printf("framing_bytecount: successful getstate\n");

  return ret;
}

int framing_bytecount_LTX_send_message(void *framing_state,void *buf,int count){
  int rc;
  int len_count;
  char *scount;
  char snbuf[1];
  struct framing_bytecount_state *state = framing_state;

  if (state->debug)
    printf("framing_bytecount: starting send_message\n");

  len_count = snprintf(snbuf,1,"%i ",count);
  scount = malloc(len_count+1);
  sprintf(scount,"%i ",count);

  rc = state->transport->writen(state->transport->state,scount,len_count);
  if (rc == -1){
    memcpy(&(state->sss_errno),state->transport->state,sizeof(int));
    return -1;
  }

  free(scount);

  rc = state->transport->writen(state->transport->state,buf,count);
  if (rc == -1){
    memcpy(&(state->sss_errno),state->transport->state,sizeof(int));
    return -1;
  }

  if (state->debug)
    printf("framing_bytecount: successful send_message\n");

  return 0;
}

char *framing_bytecount_LTX_recv_message(void *framing_state,int *count){
  int sizeoflenbuf;
  int usedlenbuf;
  char small_len_buf[2];
  int bytes_read;
  int sizeofbuf;
  char *retptr;
  struct framing_bytecount_state *state = framing_state;
  char *lenbuf = malloc(12);

  if (state->debug)
    printf("framing_bytecount: starting recv_message\n");

  sizeoflenbuf = 11;
  usedlenbuf = 0;
  small_len_buf[0] = '\0';

  bytes_read = state->transport->read(state->transport->state,small_len_buf,1);
  if (bytes_read == -1){
    memcpy(&(state->sss_errno),state->transport->state,sizeof(int));
    free(lenbuf);
    return NULL;
  }
    
  lenbuf[usedlenbuf] = small_len_buf[0];
  usedlenbuf++;
  while (small_len_buf[0] != ' '){
    bytes_read = state->transport->read(state->transport->state,small_len_buf,1);
    if (bytes_read == -1){
      memcpy(&(state->sss_errno),state->transport->state,sizeof(int));
      free(lenbuf);
      return NULL;
    }
    lenbuf[usedlenbuf] = small_len_buf[0];
    usedlenbuf++;
    if (usedlenbuf == sizeoflenbuf){
      lenbuf = realloc(lenbuf,sizeoflenbuf * 2);
      sizeoflenbuf *= 2;
    }
  }

  lenbuf[usedlenbuf-1] = '\0';

  sizeofbuf = atoi(lenbuf);
    
  free(lenbuf);

  retptr = malloc(sizeofbuf);

  bytes_read = state->transport->readn(state->transport->state,retptr,sizeofbuf);
  if (bytes_read == -1){
    memcpy(&(state->sss_errno),state->transport->state,sizeof(int));
    return NULL;
  }

  *count = sizeofbuf;

  if (state->debug)
    printf("framing_bytecount: successful recv_message\n");

  return retptr;

}

int framing_bytecount_LTX_framing_close(void *framing_state){
  int debug;
  struct framing_bytecount_state *state = framing_state;
  
  if (state->debug)
    printf("framing_bytecount: starting framing_close\n");

  debug = state->debug;

  free(framing_state);

  if (debug)
    printf("framing_bytecount: successful framing_close\n");

  return 0;

}
